package org.gemoc.execution.sequential.javaxdsml.ide.ui.menu;

import com.google.common.base.Objects;
import fr.inria.diverse.melange.metamodel.melange.Language;
import java.util.List;
import java.util.Set;
import java.util.function.Consumer;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.nodemodel.util.NodeModelUtils;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.ui.editor.XtextEditor;
import org.eclipse.xtext.ui.editor.model.IXtextDocument;
import org.eclipse.xtext.ui.editor.utils.EditorUtils;
import org.eclipse.xtext.util.concurrent.IUnitOfWork;
import org.gemoc.execution.sequential.javaxdsml.ide.ui.commands.CreateDSAProjectHandler;

@SuppressWarnings("all")
public class AddDSA extends CreateDSAProjectHandler {
  @Override
  protected void updateMelange(final ExecutionEvent event, final Language language, final Set<String> aspects) {
    final XtextEditor editor = EditorUtils.getActiveXtextEditor(event);
    boolean _notEquals = (!Objects.equal(editor, null));
    if (_notEquals) {
      final IXtextDocument document = editor.getDocument();
      final IUnitOfWork<Object, XtextResource> _function = new IUnitOfWork<Object, XtextResource>() {
        @Override
        public Object exec(final XtextResource it) throws Exception {
          EClass _eClass = language.eClass();
          final EStructuralFeature operators = _eClass.getEStructuralFeature("operators");
          final List<INode> nodesOp = NodeModelUtils.findNodesForFeature(language, operators);
          int lastOffset = (-1);
          for (final INode node : nodesOp) {
            int _endOffset = node.getEndOffset();
            boolean _greaterThan = (_endOffset > lastOffset);
            if (_greaterThan) {
              int _endOffset_1 = node.getEndOffset();
              lastOffset = _endOffset_1;
            }
          }
          if ((lastOffset != (-1))) {
            final StringBuilder insertion = new StringBuilder();
            final Consumer<String> _function = new Consumer<String>() {
              @Override
              public void accept(final String asp) {
                insertion.append((("\twith " + asp) + "\n"));
              }
            };
            aspects.forEach(_function);
            String _string = insertion.toString();
            String _plus = ("\n\n" + _string);
            document.replace(lastOffset, 0, _plus);
            return null;
          }
          return null;
        }
      };
      document.<Object>modify(_function);
    }
  }
}
